/*
    YAM - Yet Another Mod player
    Copyright 2001, 2002 Martin Storsj

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation; either version 2 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Martin Storsj
    martin@martin.st
*/

#include <stdio.h>
#include <allegro.h>
#include <string.h>
#include "audio.h"

static AUDIOSTREAM *stream;
static int length = 1024;
static int stop;
static int playing = 0;

int channels = 2;
int samplerate = 44100;
int bitdepth = 16;
int sig = 0;
int littleendian = 1;

int init_audio(void) {
	allegro_init();
	if (install_sound(DIGI_AUTODETECT,MIDI_AUTODETECT,NULL)<0) {
		fprintf(stderr,"%s\n",allegro_error);
		return 0;
	}
	stream = play_audio_stream(length,bitdepth,channels,samplerate,128,128);
	return 1;
}

void stop_audio(void) {
	remove_sound();
	allegro_exit();
}

void start_play(read_func rf, void *ptr) {
	unsigned char *buffer;
	int n;
	int size = 4*length;
	stop = 0;
	playing = 1;
	while (!stop) {
		buffer = (unsigned char*) get_audio_stream_buffer(stream);
		if (buffer==NULL) continue;
		n = rf(ptr,buffer,size);
		if (n<=0) break;
		else if (n<size) memset(buffer+n,0,size-n);
		free_audio_stream_buffer(stream);
	}
	playing = 0;
}

int is_playing(void) {
	return playing;
}

void break_play(void) {
	stop = 1;
}

